﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

public class ambientsound : MonoBehaviour
{
    int objno = 0;
    rtcmixmain RTcmix;
    private bool did_start = false;


    private void Awake()
    {
        // find the RTcmixmain object with the RTcmix function definitions
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
    }


    // Use this for initialization
    void Start()
    {
        // initialize RTcmix
        RTcmix.initRTcmix(objno);

        String score = "print_on() bus_config(\"WAVETABLE\", \"aux 0-1 out\") " +
            "bus_config(\"PANECHO\", \"aux 0-1 in\", \"out 0-1\") " +
            "ampenv = maketable(\"line\", 1000, 0,0, 50,1, 100,0) " +
            "amp = 10000 " +
            "wave = maketable(\"wave\", 1000, \"square4\") " +
            "dur = 5 " +
            "PANECHO(0, 0, 9999, 0.9, 1, 3, 0.8, 0) ";
        // send the initialization score
        RTcmix.SendScore(score, objno);

        // and then send a MAXBANG() to start the sound
        RTcmix.SendScore("MAXBANG(0.1)", objno);

        did_start = true;
    }

    void OnAudioFilterRead(float[] data, int channels)
    {
        if (!did_start) return;

        // compute sound samples
        RTcmix.runRTcmix(data, objno, 0);

        if (RTcmix.checkbangRTcmix(objno) == 1)
        {
            String score = "freq = irand(200, 400) " +
                "WAVETABLE(0, dur, amp*ampenv, freq, irand(0, 1), wave) " +
                "MAXBANG(dur * 0.3) ";
            RTcmix.SendScore(score, objno);
        }
    }


    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}
